## derivations 0.3.20060607

=== Makefile ===
all .DEFAULT : ; cd tex ; $(MAKE) $@
.PHONY       : all

=== tex/Makefile ===
SHELL  := /bin/bash

out    := derivations

def    := def.tex
main0  := main
bib    := bib.bib
tmpl0  := template

main   := $(main0).tex
ch     := $(filter-out $(main) $(def) $(wildcard $(tmpl0)-*.tex), \
  $(wildcard *.tex))

all : $(out).ps $(out).pdf
.PHONY: all

$(out).dvi : $(main) $(def) $(ch) $(bib)
	rubber $<
	mv -v $(main0).dvi $@
%.dvi      : %.tex $(def)
	rubber $<
%.ps       : %.dvi
	dvips -t letter -o $@ $<
# See the dvipdf(1) and gs(1) manpages for explanation
# of the following rule.
%.pdf      : %.ps
	gs -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sPAPERSIZE=letter \
	  -sOutputFile=$@ $<

# To "make cleanless" removes the various intermediate TeX working
# files, but leaves intact the final output document files.  The "check"
# target circumvents rubber(1), which quashes LaTeX warnings; with "make
# check", you get an extra latex(1) run which shows any warnings.
.PHONY: check cleanless clean
check      : $(out).dvi
	latex $(main)
cleanless  :
	rm -fv *.{dvi,aux,bbl,blg,idx,ilg,ind,log,lof,lot,toc,bak}
clean      : cleanless
	rm -fv *.{ps,pdf}

## derivations 0.5.20071110

=== btool/Makefile ===

prog   := complete-pdf romanize
srcdir := Util Page_no TOC PDF
warn   := -Wall -Wextra -Werror

allobj := $(foreach dir, $(srcdir), $(patsubst %.cc, %.o, \
  $(filter $(patsubst %.h, %.cc, $(wildcard $(dir)/*.h)), \
  $(wildcard $(dir)/*.cc))))

include Makefile-optim
clean := cleanless clean
.PHONY: FORCE all allobj $(clean)
all: $(prog)
ifeq ($(strip $(filter $(clean), $(MAKECMDGOALS))),)
  include $(patsubst %.cc, %.d, $(wildcard *.cc))
endif
allobj: $(allobj)
$(foreach dir, $(srcdir), $(dir)/%): FORCE; $(MAKE) -C $(@D) $(@F)
%.d: %.cc; g++ -MM $< | sed -e 's/:/ $*.d:/' >$@
%.o:; g++ $(warn) $(optim) -c $< -o $*.o

complete-pdf: complete-pdf.o $(allobj)
	g++ $(warn) $(optim) -lpoppler $^ -o $@

romanize: romanize.o Util/roman_numeral.o
	g++ $(warn) $(optim) $^ -o $@

a.out: test.o $(allobj)
	g++ $(warn) $(optim) -lpoppler $^ -o $@

cleanless:
	$(foreach dir, $(srcdir), $(MAKE) -C $(dir) clean ;)
	rm -fv *.d *.o *.gch a.out
clean: cleanless; rm -fv $(prog)

=== tex/Makefile ===

# For better or for worse, the book's build procedure has grown somewhat
# complicated over time.  This is not because the author wanted to break
# from standard LaTeX book format; he didn't and for the most part
# hasn't.  It is for small reasons, like the need to combine Timothy
# Van Zandt's PSTricks package with proper PDF page numbering, or the
# need for an extra digit of section number (10.10 instead of just 10.9)
# in the book's table of contents.
#
# Actually, for what it does, the build procedure is a good, clean
# one---or so the author believes.  If you find yourself maintaining the
# book and do not understand at first what the extra parts of the build
# procedure do, then you can remove the parts one by one until you reach
# a comfortable position, and then add the parts back one by one as you
# climb the learning curve.  Except in ../btool/fill-toc-ends
# (a minor step which you can omit if you wish with little harm), the
# build does little or nothing in a tricky way.  But, still, for a LaTeX
# document, there is admittedly a fair bit to building this one.  The
# author develops on a standard Debian platform; you might try that if
# appropriate and you think that it will help.  Good luck.
#
# On the other hand, if you do not yet know make(1), sed(1), bash(1)
# and C++, well, those are standard tools; sorry.  It's hard, but that
# is the way it has to be.  The author has tried to avoid doing things
# in *nonstandard* ways, not to avoid doing them in standard ways!  The
# author has even refrained from inflicting Perl on you, confining its
# use strictly to the optional development helpers (and has refrained
# from inflicting the Autotools even on himself); and of course he has
# written all narrative solely in English.  For certain tasks, one needs
# certain skills; so you will probably need to learn the standard tools
# make(1), sed(1), bash(1) and maybe C++, along with LaTeX and the
# English language of course, decently thoroughly to grok this source.
#
# Some comments on the last point seem in order.  If you have peeked at
# various free-software sources from time to time but have not really
# understood most of it very well, well, it must be admitted that some
# of it is not very understandable.  However, a lot of it is
# understandable; you just have to learn how to understand it.  There is
# no substitute for taking the trouble to learn.  The author stood in
# your place as recently as 1996; he had to learn, too, mostly by
# reviewing sources like the one you are reading now, not understanding,
# going away and reading dense manuals, returning, understanding a
# little more, etc.  Esoteric tools and software written in poor style,
# you can mostly ignore, but you cannot afford permanently to ignore
# sophisticated but standard techniques just because they look cryptic
# to you right now, if you want to learn to program free software.  You
# want to learn increasingly sophisticated standard techniques gradually
# over time.
#
# The author has taken moderate pains to ensure that this particular
# source makes a decent model to study, if improving your ability to
# maintain free software and to contribute to its development happens to
# be your goal.  By design, to read this source requires generally
# relevant rather than generally irrelevant programming skills.  The
# short, cryptic-looking but actually logical ../btool/Makefile-subdir
# is a particularly good example of the principle: one needs to know a
# lot to read it, but almost everything one needs to know to read it is
# well worth knowing (or you can just show it to your dad as evidence of
# what you've been doing recently; he'll think it evidence that the
# monkeys have been at your computer keyboard having another go at
# typing Hamlet).
#
# Anyway, back in 1996 the author wished that one of the free-software
# source files he was then trying to understand had taken the trouble to
# explain what the preceding paragraphs have tried to explain.  That
# might have saved the author some grief.  If the paragraphs have
# illuminated anything worth illuminating in your estimation, why, there
# they are, and make of them what you will.
#
#

SHELL  := /bin/bash

out    := derivations
class  := book

def    := def.tex
main0  := main
bib    := bib.bib
tmpl0  := template

clsdir := /usr/share/texmf-texlive/tex/latex/base

# The author cannot say definitively at which PDF level it is best to
# build the book.  Plainly, the higher the level, the greater the number
# of readers who will have trouble opening the PDF.  Also, incrementing
# the level could break the book's build tools.  The author's current
# Ghostscript can build levels 1.2, 1.3 and 1.4; all these seem to
# suffice.  As it happens, while programming the build tools, the author
# read parts of Adobe's PDF Reference 1.7, learning that level 1.5
# brings some potentially interesting features like image transparency,
# but that level 1.6 brings features of another character.  Level 1.6
# brings advanced features like encryption, interactive form pages and
# three-dimensional rendering, which are complex (thus suspected to
# break build tools) and probably mostly, maybe even wholly, useless to
# the book.  If one has no reason to do otherwise, one might refrain
# from increasing $(pdflvl) beyond 1.5 for this reason, even if and when
# Ghostscript gains the ability to produce PDF 1.6 or better.
pdflvl := 1.4

# The following are for sed(1) to adapt $(cls).  No
# parameter $(l1a) is formally defined, but this only
# because the corresponding length, 1.5em, is not
# altered; logically, l1a := 1.5em is there.
# Observe that $(l2a) = $(l1a) + $(l1b), and likewise
# that $(l3a) = $(l2a) + $(l2b); otherwise the entries
# in the book's table of contents would not fall
# visually into proper vertical line.  Observe however
# that per the original $(cls0) the pattern does not
# carry through to $(l4a).
p1   := \\newcommand\*\\l@
p2   := \\@dottedtocline
l1b  := 2.5em
l2a  := 4.0em
l2b  := 3.3em
l3a  := 7.3em

# ----------------------------------------------------------------------

main   := $(main0).tex
cls0   := $(class).cls
cls    := $(out)-$(cls0)
ch     := $(filter-out $(main) $(def) $(wildcard $(tmpl0)-*.tex), \
  $(wildcard *.tex))
define gs
	gs \
	  -dSAFER -dNOPAUSE -dBATCH \
	  -sDEVICE=pdfwrite -dCompatibilityLevel=$(pdflvl) \
	  -sPAPERSIZE=letter \
	  -sOutputFile=$@ $<
endef

.PHONY: all FORCE
all : $(out).ps $(out).pdf

$(out).dvi : $(main) $(def) $(cls) $(ch) $(bib)
	rubber $<
	mv -v $(main0).dvi $@
%.dvi      : %.tex $(def)
	rubber $<
%.ps       : %.dvi
	dvips -t letter -o $@ $<
# See the dvipdf(1), ps2pdfwr(1) and gs(1) manpages for explanation
# of the following rule.
%.pdf      : %.ps ; $(gs)

# Do you like unreadable sed(1) expressions?  Here are some.  Actually,
# if you know sed(1) and also understand the escaping role of the dollar
# sign ($) in make(1), then the expressions are not *quite* as unreadable as
# they look.  [If you do not, then you might learn when you have some time:
# sed(1) and make(1) are standard tools worth learning.]  Comments tend to grow
# outdated, so you might be wary of these words, but at the time of this
# writing the sole purpose of the sed(1) operation here is to create and modify
# a local copy of LaTeX's book class, to allow just a tad extra space between
# the section and subsection numbers and their respective titles in the book's
# table of contents (the creator of LaTeX, Leslie Lamport, evidently estimated
# section number 10.10 to be unlikely, but the book Derivations happens to have
# such sections).
$(cls)     :
	sed >$(cls) $(clsdir)/$(cls0) \
          -e 's/^\(\\ProvidesClass{\)$(class)\(}\)[[:space:]]*$$/\1$(out)-$(class)\2/' \
	  -e 's/^\($(p1)section{$(p2){1}{\)\([^{}]*\)\(}{\)\([^{}]*\)\(}}\)[[:space:]]*$$/\1\2\3$(l1b)\5/' \
	  -e 's/^\($(p1)subsection{$(p2){2}{\)\([^{}]*\)\(}{\)\([^{}]*\)\(}}\)[[:space:]]*$$/\1$(l2a)\3$(l2b)\5/' \
	  -e 's/^\($(p1)subsubsection{$(p2){3}{\)\([^{}]*\)\(}{\)\([^{}]*\)\(}}\)[[:space:]]*$$/\1$(l3a)\3\4\5/'

../btool/complete-pdf ../btool/romanize: FORCE; $(MAKE) -C $(@D) $(@F)
derivations.pdf: derivations.ps ../btool/complete-pdf
	$(gs)
	../btool/fill-toc-ends main.toc main.pgn >pdf-addendum.toc
	../btool/complete-pdf $@ $< pdf-addendum.toc >pdf-addendum
	cat pdf-addendum >>$@

# To "make cleanless" removes the various intermediate TeX working
# files, but leaves intact the final output document files.  The "check"
# target circumvents rubber(1), which quashes LaTeX warnings; with "make
# check", you get an extra latex(1) run which shows any warnings.
.PHONY: check cleanless clean
check      : $(out).dvi
	latex $(main)
cleanless  :
	rm -fv *.{cls,dvi,aux,bbl,blg,idx,ilg,ind,log,lof,lot,toc,pgn,bak} \
	  pdf-addendum
clean      : cleanless
	rm -fv *.{ps,pdf}

## derivations 0.51.20080419

=== btool/Makefile ===

prog   := complete-pdf romanize
srcdir := Util Page_no TOC PDF
warn   := -Wall -Wextra -Werror

allobj := $(foreach dir, $(srcdir), \
  $(patsubst %.cc, %.o, \
    $(filter \
      $(patsubst %.h, %.cc, $(wildcard $(dir)/*.h)), \
      $(wildcard $(dir)/*.cc) \
    ) \
  ) \
)

include Makefile-optim
clean := cleanless clean
.PHONY: FORCE all alld allobj $(clean)
all : $(prog)
# The `alld:' target seems even to the Make program itself to make
# nothing, but notice the ifneq below the target.  The include directive
# therein makes the several %.d implicitly.  (The `alld:' maneuver is to
# let "make clean [program]" work as expected.  Observe however that the
# makefile includes the several %.d before it processes any targets,
# even the `clean:' target.  If this is of concern for some
# reason---maybe because one has been monkeying with timestamps---then
# one must give "make clean" and "make [program]" as separate commands.)
alld:
ifneq ($(strip $(filter-out $(clean), $(MAKECMDGOALS))),)
  alld := $(patsubst %.cc, %.d, $(wildcard *.cc))
  include $(alld)
endif
allobj: $(allobj)
$(foreach dir, $(srcdir), $(dir)/%): FORCE; $(MAKE) -C $(@D) $(@F)
%.d: %.cc; g++ -MM $< | sed -e 's/:/ $*.d:/' >$@
%.o:; g++ $(warn) $(optim) -c $< -o $*.o

complete-pdf: complete-pdf.o $(allobj)
	g++ $(warn) $(optim) -lpoppler $^ -o $@

romanize: romanize.o Util/roman_numeral.o
	g++ $(warn) $(optim) $^ -o $@

a.out: test.o $(allobj)
	g++ $(warn) $(optim) -lpoppler $^ -o $@

cleanless:
	$(foreach dir, $(srcdir), $(MAKE) -C $(dir) clean ;)
	rm -fv *.d *.o *.gch a.out
	$(if $(alld), $(MAKE) alld)
clean: cleanless; rm -fv $(prog)

=== tex/Makefile ===
--- 
+++ 
@@ -72,9 +72,10 @@
 SHELL  := /bin/bash
 
 out    := derivations
+author := Thaddeus H. Black
 class  := book
 
-def    := def.tex
+def    := thb.sty
 main0  := main
 bib    := bib.bib
 tmpl0  := template
@@ -123,11 +124,15 @@
 ch     := $(filter-out $(main) $(def) $(wildcard $(tmpl0)-*.tex), \
   $(wildcard *.tex))
 define gs
+	touch cidfmap ; \
 	gs \
 	  -dSAFER -dNOPAUSE -dBATCH \
 	  -sDEVICE=pdfwrite -dCompatibilityLevel=$(pdflvl) \
 	  -sPAPERSIZE=letter \
 	  -sOutputFile=$@ $<
+endef
+define dvips
+	dvips -t letter -o $@ $<
 endef
 
 .PHONY: all FORCE
@@ -138,8 +143,7 @@
 	mv -v $(main0).dvi $@
 %.dvi      : %.tex $(def)
 	rubber $<
-%.ps       : %.dvi
-	dvips -t letter -o $@ $<
+%.ps       : %.dvi ; $(dvips)
 # See the dvipdf(1), ps2pdfwr(1) and gs(1) manpages for explanation
 # of the following rule.
 %.pdf      : %.ps ; $(gs)
@@ -164,6 +168,9 @@
 	  -e 's/^\($(p1)subsubsection{$(p2){3}{\)\([^{}]*\)\(}{\)\([^{}]*\)\(}}\)[[:space:]]*$$/\1$(l3a)\3\4\5/'
 
 ../btool/complete-pdf ../btool/romanize: FORCE; $(MAKE) -C $(@D) $(@F)
+derivations.ps : derivations.dvi
+	$(dvips)
+	sed -i -e 's/^\(%%Title:\).*$$/\1 $(author)/;T;:1;n;b1' $@
 derivations.pdf: derivations.ps ../btool/complete-pdf
 	$(gs)
 	../btool/fill-toc-ends main.toc main.pgn >pdf-addendum.toc
@@ -179,7 +186,7 @@
 	latex $(main)
 cleanless  :
 	rm -fv *.{cls,dvi,aux,bbl,blg,idx,ilg,ind,log,lof,lot,toc,pgn,bak} \
-	  pdf-addendum
+	  pdf-addendum cidfmap
 clean      : cleanless
 	rm -fv *.{ps,pdf}

## derivations 0.52.20100310

=== tex/Makefile ===
--- 
+++ 
@@ -150,16 +150,17 @@
 
 # Do you like unreadable sed(1) expressions?  Here are some.  Actually,
 # if you know sed(1) and also understand the escaping role of the dollar
-# sign ($) in make(1), then the expressions are not *quite* as unreadable as
-# they look.  [If you do not, then you might learn when you have some time:
-# sed(1) and make(1) are standard tools worth learning.]  Comments tend to grow
-# outdated, so you might be wary of these words, but at the time of this
-# writing the sole purpose of the sed(1) operation here is to create and modify
-# a local copy of LaTeX's book class, to allow just a tad extra space between
-# the section and subsection numbers and their respective titles in the book's
-# table of contents (the creator of LaTeX, Leslie Lamport, evidently estimated
-# section number 10.10 to be unlikely, but the book Derivations happens to have
-# such sections).
+# sign ($) in make(1), then the expressions are not *quite* as
+# unreadable as they look.  [If you do not, then you might learn when
+# you have some time: sed(1) and make(1) are standard tools worth
+# learning.]  Comments tend to grow outdated, so you might be wary of
+# these words, but at the time of this writing the sole purpose of the
+# sed(1) operation here is to create and modify a local copy of LaTeX's
+# book class, to allow just a tad extra space between the section and
+# subsection numbers and their respective titles in the book's table of
+# contents (the creator of LaTeX, Leslie Lamport, evidently estimated
+# section number 10.10 to be unlikely, but the book Derivations happens
+# to have such sections).
 $(cls)     :
 	sed >$(cls) $(clsdir)/$(cls0) \
           -e 's/^\(\\ProvidesClass{\)$(class)\(}\)[[:space:]]*$$/\1$(out)-$(class)\2/' \
@@ -174,7 +175,7 @@
 derivations.pdf: derivations.ps ../btool/complete-pdf
 	$(gs)
 	../btool/fill-toc-ends main.toc main.pgn >pdf-addendum.toc
-	../btool/complete-pdf $@ $< pdf-addendum.toc >pdf-addendum
+	../btool/complete-pdf $@ $< pdf-addendum.toc >pdf-addendum '$(author)'
 	cat pdf-addendum >>$@
 
 # To "make cleanless" removes the various intermediate TeX working

=== debian/changelog ===
derivations (0.52.20100310-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Switched to dpkg-source 3.0 (quilt) format.
  * Moved helper development files out of the Debian diff in
    'upstream_helper' patch.
  * Applied patch from Matthias Klose <doko@ubuntu.com> as
    'build_fixes' patch (Closes: #615671):
    + Fix FTBFS with g++-4.5.
    + Fix FTBFS with ld --as-needed.
    + Don't build with -Werror.
  * Added'poppler_api_change' patch to solve a libpoppler API
    change (Closes: #652081).
  * Use 'dh_prep' instead of the deprecated 'dh_clean -k'.
  * Simplified build dependencies, as suggested by Frank Küster (Closes:
    #566340).

 -- Marc Dequènes (Duck) <Duck@DuckCorp.org>  Sat, 18 Feb 2012 15:52:03 +0100

derivations (0.52.20100310-1) unstable; urgency=low

  * (Yan Morin) Fixed the broken debian/watch (closes: #550795).
    Thanked Mr. Morin for showing the maintainer how to do it.
  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.
  * Built for upload to Debian sid.
  * Updated to Debian sid's current Standards-Version: 3.8.4.
    Observed however (for the maintainer's own later reference) that
    stable Debian lenny had as of this date advanced only as far
    as Standards-Version: 3.8.0.
  * In debian/control:
    + (Jonas Smedegaard) Replaced 'gs-gpl' with 'ghostscript' as a
      build-dependency (closes: #539655).  Thanked Mr. Smedegaard
      for explaining clearly and concisely the need to do so.
    + (Michael Bienia) Allowed 'texlive-binaries' as an
      alternative build-dependency to the evidently
      deprecated 'texlive-base-bin' (closes: #566340),
      though retained for the time being the old dependency
      as an option for ease of backporting.  Thanked Mr. Bienia
      for the timely analysis thereto.
    + Per Policy 7.7, as notified by Lintian, moved the 'debhelper'
      dependency from Build-Depends-Indep to Build-Depends.
    + As Debhelper evidently demands, added "Depends: ${misc:Depends}"
      to the binary's control stanza.
    + Reviewed and updated the version-requirements of several
      other dependencies.

 -- Thaddeus H. Black <thb@debian.org>  Wed, 10 Mar 2010 00:00:00 +0000

derivations (0.52.20090107-1) experimental; urgency=low

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.

 -- Thaddeus H. Black <thb@debian.org>  Wed, 07 Jan 2009 00:00:00 +0000

derivations (0.52.20081219-1) experimental; urgency=low

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.

 -- Thaddeus H. Black <thb@debian.org>  Fri, 19 Dec 2008 00:00:00 +0000

derivations (0.52.20081003-1) experimental; urgency=low

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.
  * In helper/Def.pm, incremented $basever to 0.52.
  * Reconfigured debian/rules not to have the build die on C++ compiler
    warnings.

 -- Thaddeus H. Black <thb@debian.org>  Fri, 03 Oct 2008 00:00:00 +0000

derivations (0.51.20080419-2) unstable; urgency=low

  * Rebuilt for upload to Debian sid.
  * Updated for this upload to Standards-Version: 3.7.3.  (Upstream will
    remain at etch's 3.7.2 for the time being.)

 -- Thaddeus H. Black <thb@debian.org>  Sat, 19 Apr 2008 01:00:00 +0000

derivations (0.51.20080419-1) experimental; urgency=low

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.

 -- Thaddeus H. Black <thb@debian.org>  Sat, 19 Apr 2008 00:00:00 +0000

derivations (0.51.20080324-2) unstable; urgency=low

  * Rebuilt for upload to Debian sid.
  * Updated for this upload to Standards-Version: 3.7.3.  (Upstream will
    remain at etch's 3.7.2 for the time being.)

 -- Thaddeus H. Black <thb@debian.org>  Mon, 24 Mar 2008 01:00:00 +0000

derivations (0.51.20080324-1) experimental; urgency=low

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.
  * Elaborated the suggestions in debian/control.
  * Corrected the URL pattern in debian/watch.

 -- Thaddeus H. Black <thb@debian.org>  Mon, 24 Mar 2008 00:00:00 +0000

derivations (0.51.20080307-2) unstable; urgency=low

  * Rebuilt for upload to Debian sid.
  * Removed an unnecessary, malformed groff comment from the man page
    doc/derivations.7.
  * In debian/control, depended only on upstream package versions,
    ceasing to depend on specific Debianization versions.
  * Replaced the debian/watch placeholder with a real watch file.
  * Updated for this upload to Standards-Version: 3.7.3.  (Upstream will
    remain at etch's 3.7.2 for the time being.)

 -- Thaddeus H. Black <thb@debian.org>  Mon, 10 Mar 2008 00:00:00 +0000

derivations (0.51.20080307-1) experimental; urgency=low

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.
  * In helper/Def.pm, incremented $basever to 0.51.
  * Taught helper/ispell-all to spell-check all README files.

 -- Thaddeus H. Black <thb@debian.org>  Fri, 07 Mar 2008 00:00:00 +0000

derivations (0.5.20071222-1) experimental; urgency=low

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.
  * Observed that upstream has either incorporated the btool/ patches
    logged in (0.5.20071110-2) and (0.5.20071110-3) below or has
    rendered them unnecessary.
  * Having reviewed the relevant parts of Debian Policy, let the package


=== debian/control ===
Source: derivations
Section: doc
Priority: optional
Maintainer: Thaddeus H. Black <thb@debian.org>
Build-Depends: debhelper (>= 5)
Build-Depends-Indep: texlive-latex-base, texlive-pstricks, lmodern (>= 1.00), rubber (>= 1.1), ghostscript (>= 8.62), libpoppler-dev (>= 0.8.7)
Standards-Version: 3.8.4

Package: derivations
Section: doc
Priority: optional
Architecture: all
Depends: ${misc:Depends}
Suggests: evince | gv | pdf-viewer | postscript-viewer, ghostscript
Description: book: Derivations of Applied Mathematics
 Understandably, program sources rarely derive the mathematical formulas
 they use.  Not wishing to take the formulas on faith, a user might
 nevertheless reasonably wish to see such formulas somewhere derived.
 .
 Derivations of Applied Mathematics is a book which documents and
 derives many of the mathematical formulas and methods implemented in
 free software or used in science and engineering generally.  It
 documents and derives the Taylor series (used to calculate
 trigonometrics), the Newton-Raphson method (used to calculate square
 roots), the Pythagorean theorem (used to calculate distances) and many
 others.

## derivations 0.53.20120414

=== btool/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 prog   := complete-pdf romanize
 srcdir := Util Page_no TOC PDF
-warn   := -Wall -Wextra -Werror
+warn   := -Wall -Wextra
 
 allobj := $(foreach dir, $(srcdir), \
   $(patsubst %.cc, %.o, \
@@ -13,6 +13,7 @@
 )
 
 include Makefile-optim
+warn  += $(werror)
 clean := cleanless clean
 .PHONY: FORCE all alld allobj $(clean)
 all : $(prog)

=== tex/Makefile ===
--- 
+++ 
@@ -80,7 +80,7 @@
 bib    := bib.bib
 tmpl0  := template
 
-clsdir := /usr/share/texmf-texlive/tex/latex/base
+clsdir := /usr/share/texlive/texmf-dist/tex/latex/base
 
 # The author cannot say definitively at which PDF level it is best to
 # build the book.  Plainly, the higher the level, the greater the number

=== debian/changelog ===
derivations (0.53.20120414-2) unstable; urgency=low

  * Thanked Pino Toscano and Michael Gilbert for their helpful NMUs.
  * Filled the gap left by Libpoppler's new unwillingness to find a PDF file's
    last XRef table (closes: #668907). Recognized Salvatore Bonaccorso for
    drawing attention to this bug.

 -- Thaddeus H. Black <thb@debian.org>  Mon, 1 Jun 2015 00:00:00 +0000

derivations (0.53.20120414-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Automatically support poppler api changes (closes: #690161).
    - Thanks to Pino Toscano.

 -- Michael Gilbert <mgilbert@debian.org>  Sun, 26 Jan 2014 21:58:55 +0000

derivations (0.53.20120414-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Switch the libpoppler-dev build dependency to libpoppler-private-dev
    (closes: #660986).

 -- Pino Toscano <pino@debian.org>  Fri, 15 Jun 2012 17:50:18 +0200

derivations (0.53.20120414-1) unstable; urgency=low

  * Thanked Marc Dequènes (Duck) for his timely NMU.
  * Preserved Mr. Dequènes' repackaging while updating the book's text
    to that of the most recent upstream version.
  * Updated tex/Makefile to find LaTeX's book class at its new
    location (closes: #666619).  Thanked Lucas Nussbaum for the
    associated bug report.

 -- Thaddeus H. Black <thb@debian.org>  Sat, 14 Apr 2012 00:00:00 +0000

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Thaddeus H. Black <thb@debian.org>
 Build-Depends: debhelper (>= 5)
-Build-Depends-Indep: texlive-latex-base, texlive-pstricks, lmodern (>= 1.00), rubber (>= 1.1), ghostscript (>= 8.62), libpoppler-dev (>= 0.8.7)
-Standards-Version: 3.8.4
+Build-Depends-Indep: texlive-latex-base, texlive-pstricks, lmodern (>= 1.00), rubber (>= 1.1), ghostscript (>= 8.62), libpoppler-private-dev (>= 0.8.7), pkg-config
+Standards-Version: 3.9.6
 
 Package: derivations
 Section: doc

=== debian/watch ===
# Thanks to Yan Morin for correcting this Debian watch file (refer
# to [http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=550795]).

version=3
http://www.derivations.org/ ./derivations_([^\s_-]+)\.orig\.tar\.gz

## derivations 0.56.20180123.1

=== Makefile ===
srcdir := btool tex
.PHONY: FORCE all clean
all:
all clean: ; $(foreach dir, $(srcdir), $(MAKE) -C $(dir) $@ ;)
$(foreach dir, $(srcdir), $(dir)/%): FORCE; $(MAKE) -C $(@D) $(@F)

=== btool/Makefile ===
--- 
+++ 
@@ -33,16 +33,16 @@
 allobj: $(allobj)
 $(foreach dir, $(srcdir), $(dir)/%): FORCE; $(MAKE) -C $(@D) $(@F)
 %.d: %.cc; g++ -MM $< | sed -e 's/:/ $*.d:/' >$@
-%.o:; g++ $(warn) $(optim) -c $< -o $*.o
+%.o: %.cc; g++ $(warn) $(optim) $(CXXFLAGS) -c $< -o $*.o
 
 complete-pdf: complete-pdf.o $(allobj)
-	g++ $(warn) $(optim) -lpoppler $^ -o $@
+	g++ $(warn) $(optim) $^ -lpoppler -o $@
 
 romanize: romanize.o Util/roman_numeral.o
 	g++ $(warn) $(optim) $^ -o $@
 
 a.out: test.o $(allobj)
-	g++ $(warn) $(optim) -lpoppler $^ -o $@
+	g++ $(warn) $(optim) $^ -lpoppler -o $@
 
 cleanless:
 	$(foreach dir, $(srcdir), $(MAKE) -C $(dir) clean ;)

=== tex/Makefile ===
--- 
+++ 
@@ -164,7 +164,7 @@
 $(cls)     :
 	sed >$(cls) $(clsdir)/$(cls0) \
           -e 's/^\(\\ProvidesClass{\)$(class)\(}\)[[:space:]]*$$/\1$(out)-$(class)\2/' \
-	  -e 's/^\($(p1)section{$(p2){1}{\)\([^{}]*\)\(}{\)\([^{}]*\)\(}}\)[[:space:]]*$$/\1\2\3$(l1b)\5/' \
+	  -e 's/^\($(p1)\(section\|figure\){$(p2){1}{\)\([^{}]*\)\(}{\)\([^{}]*\)\(}}\)[[:space:]]*$$/\1\3\4$(l1b)\6/' \
 	  -e 's/^\($(p1)subsection{$(p2){2}{\)\([^{}]*\)\(}{\)\([^{}]*\)\(}}\)[[:space:]]*$$/\1$(l2a)\3$(l2b)\5/' \
 	  -e 's/^\($(p1)subsubsection{$(p2){3}{\)\([^{}]*\)\(}{\)\([^{}]*\)\(}}\)[[:space:]]*$$/\1$(l3a)\3\4\5/'

=== debian/changelog ===
derivations (0.56.20180123.1-2) unstable; urgency=low

  * Reconfigured and rebuilt for upload to Debian sid.
  * Conformed to Standards-Version 4.3.0.
  * Conformed btool/ to sid's Poppler, version 0.69 (closes: #884476).
    Required at least this version of Poppler to build.

 -- Thaddeus H. Black <thb@debian.org>  Sat, 05 Jan 2019 01:00:00 +0000

derivations (0.56.20180123.1-1) experimental; urgency=none

  * Updated to the new upstream version.
  * Conformed to Standards-Version 3.9.8.
  * In debian/control, required build dependencies to have advanced at
    least as far as the versions shipped with Debian stretch stable.
    (Reason:  to build the present issue on older Debians has not been
    tried by the package's maintainer.)
  * Noticing that libpoppler-private-dev, version 0.69, breaks the
    build, observing that version 0.48 does not break it, and remaining
    unsure regarding versions between, forbade versions of
    libpoppler-private-dev other than 0.48.  (Buster's derivations
    is to relieve the restriction but the present revision, never
    uploaded to Debian's archive, chiefly targets stretch stable.)
  * De-Quilted the source.  Observed that this does not mean that Quilt
    can no longer be used -- for some future revisions of the package
    are likely to be re-Quilted -- but it does mean that spurious Quilt
    files and directories no longer need to be (and no longer should
    be) left lying about during times at which there are no patches for
    Quilt to manage.
  * Added the script debian/helper/rm-quilt to help with future
    de-Quilting if and as needed.  Added a corresponding paragraph
    to debian/helper/RelSteps.
  * To avoid confusion, emphasized here that the package's Debian
    source format remains 3.0 (quilt) whether or not Quilt has patches
    to manage.  It's just that Quilt's *files* can now be omitted when
    there are no patches.
  * Updated debian/copyright to point the user to the source's
    current location.
  * Advanced to build using Debhelper 10.

 -- Thaddeus H. Black <thb@debian.org>  Sat, 05 Jan 2019 00:00:00 +0000

derivations (0.56.20180123-1) experimental; urgency=none

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.

 -- Thaddeus H. Black <thb@debian.org>  Tue, 23 Jan 2018 00:00:00 +0000

derivations (0.55.20180117-1) experimental; urgency=none

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.
  * Corrected debian/helper/RelSteps in various minor ways, for example
    to report the new path to the helper scripts and to refer to the new
    package format.

 -- Thaddeus H. Black <thb@debian.org>  Wed, 17 Jan 2018 00:00:00 +0000

derivations (0.55.20170703-1) experimental; urgency=none

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.

 -- Thaddeus H. Black <thb@debian.org>  Mon, 03 Jul 2017 00:00:00 +0000

derivations (0.55.20170620-1) experimental; urgency=none

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.

 -- Thaddeus H. Black <thb@debian.org>  Tue, 20 Jun 2017 00:00:00 +0000

derivations (0.55.20170612-1) experimental; urgency=none

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.

 -- Thaddeus H. Black <thb@debian.org>  Mon, 12 Jun 2017 00:00:00 +0000

derivations (0.55.20170530-1) experimental; urgency=none

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.

 -- Thaddeus H. Black <thb@debian.org>  Tue, 30 May 2017 00:00:00 +0000

derivations (0.54.20170508-1) experimental; urgency=none

  * Updated to the new upstream version.  Refer to doc/changelog in the
    source or to /usr/share/doc/derivations/changelog.gz in the binary
    for details.
  * Because the .ps format is not much used any more as far as the
    writer knows, excluded the .ps from the binary package.  (Still
    included the .pdf, of course.)
  * In consideration of helpful NMUs, reconfigured some parts of the
    build process for the time being so that they make more sense to
    the package maintainer than to the NMUer.
  * Relocated helper/ as debian/helper.
  * Conformed the Description in debian/control to the new upstream
    version's self-description.

 -- Thaddeus H. Black <thb@debian.org>  Mon, 08 May 2017 00:00:00 +0000

=== debian/control ===
Source: derivations
Section: doc
Priority: optional
Maintainer: Thaddeus H. Black <thb@debian.org>
Build-Depends: debhelper (>= 10)
Build-Depends-Indep: texlive-latex-base (>= 2016), texlive-pstricks (>= 2016), lmodern (>= 2.004), rubber (>= 1.4), ghostscript (>= 9.20~dfsg), libpoppler-private-dev (>= 0.69), pkg-config (>= 0.29)
Standards-Version: 4.3.0

Package: derivations
Section: doc
Priority: optional
Architecture: all
Depends: ${misc:Depends}
Suggests: evince | pdf-viewer
Description: book: Derivations of Applied Mathematics
 For various valid reasons, open-source program sources rarely derive
 the mathematical formulas they use.  A user, nevertheless -- not
 wishing to take such formulas on faith -- might wish to see such
 formulas *somewhere* derived.
 .
 Derivations of Applied Mathematics is a book that derives, and
 documents, many of the mathematical formulas and methods open-source
 programs use, and indeed many of the formulas and methods used in
 science and engineering generally.  For example, it derives and
 documents the Taylor series (used to calculate trigonometrics), the
 Newton-Raphson method (used to calculate square roots), the Pythagorean
 theorem (used to calculate distances) and many others.
 .
 The book's format is PDF.

=== debian/rules ===
#! /usr/bin/make -f

tex    := tex
out    := derivations

# Uncomment for Debhelper verbosity.
#export DH_VERBOSE=1

configure       : configure-stamp
configure-stamp :
	dh_testdir
	@# (Further configuration commands probably go here.)
	touch configure-stamp

build           : build-stamp
build-arch      : build-stamp
build-indep     : build-stamp
build-stamp     : configure-stamp
	dh_testdir
	BUILD_FOR_PACKAGING=1 $(MAKE) $(tex)/$(out).ps $(tex)/$(out).pdf
	@# (Further build commands probably go here.)
	touch build-stamp

clean           :
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	$(MAKE) clean
	@# (Further cleaning commands probably go here.)
	dh_clean

install         : build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	@# (Further installation commands probably go here.)

binary-indep    : build install
	dh_testdir
	dh_testroot
	dh_installchangelogs doc/changelog
	dh_installdocs
	dh_installman
	@# (Further commands regarding the preparation of the
	@# architecture-independent binary probably go here.)
	dh_link
	dh_compress -X.pdf
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb
binary          : binary-indep
binary-arch     : ;

# These are optional targets.
orig            : ; dh_testdir ; bash - debian/mkorig
orig-force      : ; dh_testdir ; bash - debian/mkorig -f
cleandeb-force  : ; dh_testdir ; bash - debian/cleandeb -f

.PHONY: configure build clean install binary-indep binary \
  orig orig-force cleandeb-force
